| ghc-6.10.4: The GHC API | Contents | Index

VectMonad

Documentation
data Scope a b

Constructors

Global a |
Local b |

data VM a

Instances

Monad VM

noV :: VM a
traceNoV :: String -> SDoc -> VM a
tryV :: VM a -> VM (Maybe a)
maybeV :: VM (Maybe a) -> VM a
traceMaybeV :: String -> SDoc -> VM (Maybe a) -> VM a
orElseV :: VM a -> VM a -> VM a
fixV :: (a -> VM a) -> VM a
localV :: VM a -> VM a
closedV :: VM a -> VM a
initV :: PackageId -> HscEnv -> ModGuts -> VectInfo -> VM a -> IO (Maybe (VectInfo, a))
cantVectorise :: String -> SDoc -> a
maybeCantVectorise :: String -> SDoc -> Maybe a -> a
maybeCantVectoriseM :: Monad m => String -> SDoc -> m (Maybe a) -> m a
liftDs :: DsM a -> VM a
cloneName :: (OccName -> OccName) -> Name -> VM Name
cloneId :: (OccName -> OccName) -> Id -> Type -> VM Id
cloneVar :: Var -> VM Var
newExportedVar :: OccName -> Type -> VM Var
newLocalVar :: FastString -> Type -> VM Var
newDummyVar :: Type -> VM Var
newTyVar :: FastString -> Kind -> VM Var
data Builtins

Constructors

Builtins |

dphModules :: Modules |
parrayTyCon :: TyCon |
paTyCon :: TyCon |
paDataCon :: DataCon |
preprTyCon :: TyCon |
prTyCon :: TyCon |
prDataCon :: DataCon |
intPrimArrayTy :: Type |
voidTyCon :: TyCon |
wrapTyCon :: TyCon |
enumerationTyCon :: TyCon |
sumTyCons :: Array Int TyCon |
closureTyCon :: TyCon |
voidVar :: Var |
mkPRVar :: Var |
mkClosureVar :: Var |
applyClosureVar :: Var |
mkClosurePVar :: Var |
applyClosurePVar :: Var |
replicatePAIntPrimVar :: Var |
upToPAIntPrimVar :: Var |
selectPAIntPrimVar :: Var |
truesPABoolPrimVar :: Var |
lengthPAVar :: Var |
replicatePAVar :: Var |
emptyPAVar :: Var |
packPAVar :: Var |
combinePAVars :: Array Int Var |
liftingContext :: Var |

sumTyCon :: Int -> Builtins -> TyCon
prodTyCon :: Int -> Builtins -> TyCon
combinePAVar :: Int -> Builtins -> Var
builtin :: (Builtins -> a) -> VM a
builtins :: (a -> Builtins -> b) -> VM (a -> b)
data GlobalEnv

Constructors

GlobalEnv |

global_vars :: VarEnv Var |
global_exported_vars :: VarEnv (Var, Var) |
global_tycons :: NameEnv TyCon |
global_datacons :: NameEnv DataCon |
global_pa_funs :: NameEnv Var |
global_pr_funs :: NameEnv Var |
global_boxed_tycons :: NameEnv TyCon |
global_inst_env :: (InstEnv, InstEnv) |
global_fam_inst_env :: FamInstEnvs |
global_bindings :: [(Var, CoreExpr)] |

setFamInstEnv :: FamInstEnv -> GlobalEnv -> GlobalEnv
readGEnv :: (GlobalEnv -> a) -> VM a
setGEnv :: GlobalEnv -> VM ()
updGEnv :: (GlobalEnv -> GlobalEnv) -> VM ()
data LocalEnv

Constructors

LocalEnv |

local_vars :: VarEnv (Var, Var) |
local_tyvars :: [TyVar] |
local_tyvar_pa :: VarEnv CoreExpr |
local_bind_name :: FastString |

readLEnv :: (LocalEnv -> a) -> VM a
setLEnv :: LocalEnv -> VM ()
updLEnv :: (LocalEnv -> LocalEnv) -> VM ()
getBindName :: VM FastString
inBind :: Id -> VM a -> VM a
lookupVar :: Var -> VM (Scope Var (Var, Var))
defGlobalVar :: Var -> Var -> VM ()
lookupTyCon :: TyCon -> VM (Maybe TyCon)
defTyCon :: TyCon -> TyCon -> VM ()
lookupDataCon :: DataCon -> VM (Maybe DataCon)
defDataCon :: DataCon -> DataCon -> VM ()
lookupTyConPA :: TyCon -> VM (Maybe Var)
defTyConPA :: TyCon -> Var -> VM ()
defTyConPAs :: [(TyCon, Var)] -> VM ()
lookupTyConPR :: TyCon -> VM (Maybe Var)
lookupBoxedTyCon :: TyCon -> VM (Maybe TyCon)
lookupPrimMethod :: TyCon -> String -> VM (Maybe Var)
lookupPrimPArray :: TyCon -> VM (Maybe TyCon)
lookupTyVarPA :: Var -> VM (Maybe CoreExpr)
defLocalTyVar :: TyVar -> VM ()
defLocalTyVarWithPA :: TyVar -> CoreExpr -> VM ()
localTyVars :: VM [TyVar]
lookupFamInst :: TyCon -> [Type] -> VM (TyCon, [Type])
Produced by Haddock version 2.4.2